//
//  ReceiptsDetailHeaderCell.swift
//  oin_pos_plugin
//
//  Created by 逸唐陳 on 2020/8/21.
//

import UIKit

class ReceiptsDetailHeaderCell: UITableViewCell {
  
  let storeName: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "碳佐麻里精品燒肉"
    label.textAlignment = .center
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 35, weight: .light)
    return label
  }()
  
  let detailTitle: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "交易明細－內用A4"
    label.textAlignment = .center
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 45, weight: .light)
    return label
  }()
  
  let branchName: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "門市：高雄美術店"
    label.textAlignment = .left
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  let date: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "交易時間：2020/07/07 14:55"
    label.textAlignment = .left
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  let number: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "單號：120071300043"
    label.textAlignment = .left
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  let container: UIView = {
    let view = UIView()
    view.translatesAutoresizingMaskIntoConstraints = false
    view.backgroundColor = .white
    return view
  }()
  
  let separator1: UIView = {
    let view = UIView()
    view.translatesAutoresizingMaskIntoConstraints = false
    view.backgroundColor = .black
    return view
  }()
  
  let separator2: UIView = {
    let view = UIView()
    view.translatesAutoresizingMaskIntoConstraints = false
    view.backgroundColor = .black
    return view
  }()
  
  let productName: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "品名"
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  let amount: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "數量"
    label.textColor = .black
    label.textAlignment = .center
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  let tip: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "小記"
    label.textColor = .black
    label.textAlignment = .right
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
    super.init(style: style, reuseIdentifier: reuseIdentifier)
    selectionStyle = .none
    backgroundColor = .white
    contentView.addSubview(storeName)
    storeName.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    storeName.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    storeName.topAnchor.constraint(equalTo: contentView.topAnchor).isActive = true
    storeName.heightAnchor.constraint(equalToConstant: 50).isActive = true
    contentView.addSubview(detailTitle)
    detailTitle.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    detailTitle.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    detailTitle.topAnchor.constraint(equalTo: storeName.bottomAnchor, constant: 5).isActive = true
    detailTitle.heightAnchor.constraint(equalToConstant: 50).isActive = true
    contentView.addSubview(branchName)
    branchName.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 20).isActive = true
    branchName.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -20).isActive = true
    branchName.heightAnchor.constraint(equalToConstant: 30).isActive = true
    branchName.topAnchor.constraint(equalTo: detailTitle.bottomAnchor, constant: 15).isActive = true
    contentView.addSubview(date)
    date.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 20).isActive = true
    date.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -20).isActive = true
    date.heightAnchor.constraint(equalToConstant: 30).isActive = true
    date.topAnchor.constraint(equalTo: branchName.bottomAnchor, constant: 5).isActive = true
    contentView.addSubview(number)
    number.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 20).isActive = true
    number.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -20).isActive = true
    number.heightAnchor.constraint(equalToConstant: 30).isActive = true
    number.topAnchor.constraint(equalTo: date.bottomAnchor, constant: 5).isActive = true
    contentView.addSubview(separator1)
    separator1.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    separator1.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    separator1.topAnchor.constraint(equalTo: number.bottomAnchor, constant: 10).isActive = true
    separator1.heightAnchor.constraint(equalToConstant: 2).isActive = true
    contentView.addSubview(productName)
    productName.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 25).isActive = true
    productName.heightAnchor.constraint(equalToConstant: 30).isActive = true
    productName.topAnchor.constraint(equalTo: separator1.bottomAnchor, constant: 10).isActive = true
    productName.widthAnchor.constraint(equalTo: widthAnchor, multiplier: 0.5, constant: -25).isActive = true
    contentView.addSubview(tip)
    tip.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -15).isActive = true
    tip.heightAnchor.constraint(equalToConstant: 30).isActive = true
    tip.topAnchor.constraint(equalTo: separator1.bottomAnchor, constant: 10).isActive = true
    tip.widthAnchor.constraint(equalTo: widthAnchor, multiplier: 0.3, constant: -10).isActive = true
    contentView.addSubview(amount)
    amount.leadingAnchor.constraint(equalTo: productName.trailingAnchor).isActive = true
    amount.trailingAnchor.constraint(equalTo: tip.leadingAnchor).isActive = true
    amount.heightAnchor.constraint(equalToConstant: 30).isActive = true
    amount.topAnchor.constraint(equalTo: separator1.bottomAnchor, constant: 10).isActive = true
    contentView.addSubview(separator2)
    separator2.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    separator2.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    separator2.topAnchor.constraint(equalTo: amount.bottomAnchor, constant: 10).isActive = true
    separator2.heightAnchor.constraint(equalToConstant: 2).isActive = true
    separator2.bottomAnchor.constraint(equalTo: contentView.bottomAnchor, constant: -20).isActive = true
  }
  
  required init?(coder: NSCoder) {
    fatalError("init(coder:) has not been implemented")
  }
}
