//
//  ReceiptsDiscountCell.swift
//  oin_pos_plugin
//
//  Created by 逸唐陳 on 2020/8/25.
//

import UIKit

class ReceiptsDiscountCell: UITableViewCell {
  
  let title: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 25, weight: .regular)
    return label
  }()
  
  let separator: UIView = {
    let view = UIView()
    view.translatesAutoresizingMaskIntoConstraints = false
    view.backgroundColor = .black
    return view
  }()
  
  lazy var tableView: UITableView = {
    let view = UITableView(frame: .zero, style: .plain)
    view.translatesAutoresizingMaskIntoConstraints = false
    view.separatorStyle = .none
    view.backgroundColor = .white
    view.rowHeight = 50
    view.tableFooterView = UIView()
    view.delegate = self
    view.dataSource = self
    view.isScrollEnabled = false
    return view
  }()
  
  var discounts = [Discount]()
  
  override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
    super.init(style: style, reuseIdentifier: reuseIdentifier)
    selectionStyle = .none
    backgroundColor = .white
    contentView.addSubview(title)
    title.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 10).isActive = true
    title.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -10).isActive = true
    title.heightAnchor.constraint(equalToConstant: 30).isActive = true
    title.topAnchor.constraint(equalTo: contentView.topAnchor, constant: 20).isActive = true
    contentView.addSubview(separator)
    separator.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    separator.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    separator.topAnchor.constraint(equalTo: title.bottomAnchor, constant: 20).isActive = true
    separator.heightAnchor.constraint(equalToConstant: 2).isActive = true
    contentView.addSubview(tableView)
    tableView.topAnchor.constraint(equalTo: separator.bottomAnchor).isActive = true
    tableView.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    tableView.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    tableView.bottomAnchor.constraint(equalTo: bottomAnchor).isActive = true
    tableView.register(GiftCell.self, forCellReuseIdentifier: "cell")
  }
  
  required init?(coder: NSCoder) {
    fatalError("init(coder:) has not been implemented")
  }
}

extension ReceiptsDiscountCell: UITableViewDelegate {}
extension ReceiptsDiscountCell: UITableViewDataSource {
  func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
    return discounts.count
  }
  
  func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
    let cell = tableView.dequeueReusableCell(withIdentifier: "cell", for: indexPath) as! GiftCell
    cell.name.text = discounts[indexPath.row].name
    cell.amount.text = "\(discounts[indexPath.row].amount)"
    cell.price.text = discounts[indexPath.row].price
    return cell
  }
}
