//
//  ReceiptsStoreCell.swift
//  oin_pos_plugin
//
//  Created by 逸唐陳 on 2020/8/10.
//

import UIKit

class ReceiptsStoreCell: UITableViewCell {
  
  let storeName: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "碳佐麻里精品燒肉"
    label.textAlignment = .center
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 35, weight: .light)
    return label
  }()
  
  let separator: UIView = {
    let view = UIView()
    view.translatesAutoresizingMaskIntoConstraints = false
    view.backgroundColor = UIColor(red: 225/255, green: 225/255, blue: 225/255, alpha: 1)
    return view
  }()
  
  let invoiceTitle: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "電子發票證明聯"
    label.textAlignment = .center
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 45, weight: .light)
    return label
  }()
  
  let invoiceDate: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "109年05-06月"
    label.textAlignment = .center
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 45, weight: .light)
    return label
  }()
  
  let invoiceNumber: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "EV-123456789"
    label.textAlignment = .center
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 45, weight: .light)
    return label
  }()
  
  let date: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "2020/08/10 16:57"
    label.textAlignment = .left
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  let randomNumber: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "隨機碼：9876"
    label.textAlignment = .left
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  let total: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "總計：1,068"
    label.textAlignment = .right
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  let sellCode: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.text = "賣方：213213"
    label.textAlignment = .left
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 25, weight: .thin)
    return label
  }()
  
  let barcodeView: UIImageView = {
    let view = UIImageView()
    view.translatesAutoresizingMaskIntoConstraints = false
    view.image = UIImage(barcode: "Test 1234567123213123")
    view.clipsToBounds = true
    view.backgroundColor = .clear
    view.layer.masksToBounds = true
    return view
  }()
  
  let leftQRCode: UIImageView = {
    let view = UIImageView()
    view.translatesAutoresizingMaskIntoConstraints = false
    view.image = UIImage(qrcode: "Test 1234567123213123")
    view.clipsToBounds = true
    view.backgroundColor = .clear
    view.layer.masksToBounds = true
    return view
  }()
  
  let rightQRCode: UIImageView = {
    let view = UIImageView()
    view.translatesAutoresizingMaskIntoConstraints = false
    view.image = UIImage(qrcode: "Test 1234567123213123")
    view.clipsToBounds = true
    view.backgroundColor = .clear
    view.layer.masksToBounds = true
    return view
  }()
  
  override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
    super.init(style: style, reuseIdentifier: reuseIdentifier)
    selectionStyle = .none
    backgroundColor = .white
    contentView.addSubview(storeName)
    storeName.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    storeName.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    storeName.topAnchor.constraint(equalTo: contentView.topAnchor).isActive = true
    storeName.heightAnchor.constraint(equalToConstant: 50).isActive = true
    contentView.addSubview(invoiceTitle)
    invoiceTitle.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    invoiceTitle.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    invoiceTitle.topAnchor.constraint(equalTo: storeName.bottomAnchor, constant: 5).isActive = true
    invoiceTitle.heightAnchor.constraint(equalToConstant: 50).isActive = true
    contentView.addSubview(invoiceDate)
    invoiceDate.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    invoiceDate.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    invoiceDate.topAnchor.constraint(equalTo: invoiceTitle.bottomAnchor, constant: 5).isActive = true
    invoiceDate.heightAnchor.constraint(equalToConstant: 50).isActive = true
    contentView.addSubview(invoiceNumber)
    invoiceNumber.leadingAnchor.constraint(equalTo: leadingAnchor).isActive = true
    invoiceNumber.trailingAnchor.constraint(equalTo: trailingAnchor).isActive = true
    invoiceNumber.topAnchor.constraint(equalTo: invoiceDate.bottomAnchor, constant: 5).isActive = true
    invoiceNumber.heightAnchor.constraint(equalToConstant: 50).isActive = true
    contentView.addSubview(date)
    date.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 20).isActive = true
    date.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -20).isActive = true
    date.heightAnchor.constraint(equalToConstant: 30).isActive = true
    date.topAnchor.constraint(equalTo: invoiceNumber.bottomAnchor, constant: 5).isActive = true
    contentView.addSubview(randomNumber)
    randomNumber.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 20).isActive = true
    randomNumber.widthAnchor.constraint(lessThanOrEqualToConstant: 200).isActive = true
    randomNumber.heightAnchor.constraint(lessThanOrEqualToConstant: 30).isActive = true
    randomNumber.topAnchor.constraint(equalTo: date.bottomAnchor, constant: 5).isActive = true
    contentView.addSubview(total)
    total.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -20).isActive = true
    total.heightAnchor.constraint(equalToConstant: 30).isActive = true
    total.widthAnchor.constraint(lessThanOrEqualToConstant: 200).isActive = true
    total.topAnchor.constraint(equalTo: date.bottomAnchor, constant: 5).isActive = true
    contentView.addSubview(sellCode)
    sellCode.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 20).isActive = true
    sellCode.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -20).isActive = true
    sellCode.heightAnchor.constraint(equalToConstant: 30).isActive = true
    sellCode.topAnchor.constraint(equalTo: randomNumber.bottomAnchor, constant: 5).isActive = true
    contentView.addSubview(barcodeView)
    barcodeView.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 20).isActive = true
    barcodeView.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -20).isActive = true
    barcodeView.heightAnchor.constraint(equalToConstant: 100).isActive = true
    barcodeView.topAnchor.constraint(equalTo: sellCode.bottomAnchor).isActive = true
    contentView.addSubview(leftQRCode)
    leftQRCode.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 30).isActive = true
    leftQRCode.topAnchor.constraint(equalTo: barcodeView.bottomAnchor).isActive = true
    leftQRCode.heightAnchor.constraint(equalToConstant: 180).isActive = true
    leftQRCode.widthAnchor.constraint(equalToConstant: 180).isActive = true
    contentView.addSubview(rightQRCode)
    rightQRCode.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -30).isActive = true
    rightQRCode.topAnchor.constraint(equalTo: barcodeView.bottomAnchor).isActive = true
    rightQRCode.heightAnchor.constraint(equalToConstant: 180).isActive = true
    rightQRCode.widthAnchor.constraint(equalToConstant: 180).isActive = true
    rightQRCode.bottomAnchor.constraint(equalTo: contentView.bottomAnchor, constant: -20).isActive = true
  }
  
  required init?(coder: NSCoder) {
    fatalError("init(coder:) has not been implemented")
  }
}
