//
//  ReceiptsTotalCell.swift
//  oin_pos_plugin
//
//  Created by 逸唐陳 on 2020/8/25.
//

import UIKit

class ReceiptsTotalCell: UITableViewCell {
  
  let invoicePrice: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 30, weight: .regular)
    label.text = "發票金額＄8591"
    return label
  }()
  
  let pay: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 26, weight: .thin)
    label.text = "現金＄10000"
    return label
  }()
  
  let change: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.textColor = .black
    label.textAlignment = .right
    label.font = UIFont.systemFont(ofSize: 26, weight: .thin)
    label.text = "找零＄1409"
    return label
  }()
  
  let prompt: UILabel = {
    let label = UILabel()
    label.translatesAutoresizingMaskIntoConstraints = false
    label.textColor = .black
    label.font = UIFont.systemFont(ofSize: 26, weight: .thin)
    label.text = "退貨憑電子發票證明聯正本辦理"
    return label
  }()
  
  override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
    super.init(style: style, reuseIdentifier: reuseIdentifier)
    selectionStyle = .none
    backgroundColor = .white
    contentView.addSubview(invoicePrice)
    invoicePrice.topAnchor.constraint(equalTo: contentView.topAnchor, constant: 20).isActive = true
    invoicePrice.heightAnchor.constraint(equalToConstant: 35).isActive = true
    invoicePrice.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 10).isActive = true
    invoicePrice.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -10).isActive = true
    contentView.addSubview(pay)
    pay.topAnchor.constraint(equalTo: invoicePrice.bottomAnchor, constant: 10).isActive = true
    pay.heightAnchor.constraint(equalToConstant: 30).isActive = true
    pay.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 10).isActive = true
    pay.trailingAnchor.constraint(equalTo: centerXAnchor).isActive = true
    contentView.addSubview(change)
    change.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -15).isActive = true
    change.heightAnchor.constraint(equalToConstant: 30).isActive = true
    change.leadingAnchor.constraint(equalTo: centerXAnchor).isActive = true
    change.topAnchor.constraint(equalTo: invoicePrice.bottomAnchor, constant: 10).isActive = true
    contentView.addSubview(prompt)
    prompt.leadingAnchor.constraint(equalTo: leadingAnchor, constant: 10).isActive = true
    prompt.trailingAnchor.constraint(equalTo: trailingAnchor, constant: -10).isActive = true
    prompt.heightAnchor.constraint(equalToConstant: 30).isActive = true
    prompt.topAnchor.constraint(equalTo: pay.bottomAnchor, constant: 10).isActive = true
    prompt.bottomAnchor.constraint(equalTo: contentView.bottomAnchor, constant: -20).isActive = true
  }
  
  required init?(coder: NSCoder) {
    fatalError("init(coder:) has not been implemented")
  }
}
