//
//  Barcode.swift
//  oin_pos_plugin
//
//  Created by 逸唐陳 on 2020/8/21.
//

import UIKit

extension UIImage {
  
  convenience init?(barcode: String) {
    let data = barcode.data(using: .ascii)
    guard let filter = CIFilter(name: "CICode128BarcodeGenerator") else {
      return nil
    }
    filter.setValue(data, forKey: "inputMessage")
    let transform = CGAffineTransform(scaleX: 5, y: 5)
    guard let ciImage = filter.outputImage?.transformed(by: transform) else {
      return nil
    }
    self.init(ciImage: ciImage)
  }
  
  convenience init?(qrcode: String) {
    let data = qrcode.data(using: .ascii)
    guard let filter = CIFilter(name: "CIQRCodeGenerator") else {
      return nil
    }
    filter.setValue(data, forKey: "inputMessage")
    let transform = CGAffineTransform(scaleX: 5, y: 5)
    guard let ciImage = filter.outputImage?.transformed(by: transform) else {
      return nil
    }
    self.init(ciImage: ciImage)
  }
  
}


