//
//  Receipts.swift
//  oin_pos_plugin
//
//  Created by 逸唐陳 on 2020/8/24.
//

import Foundation

struct Receipts: Decodable {
  let storeName: String
  let invoiceNumber: String
  let orders: [Order]
  let gift: [Gift]?
  let discount: [Discount]?
  let total: String
}

extension Receipts {
  var comboHeight: CGFloat {
    var height: CGFloat = 0
    for order in orders {
      height += order.comboHeight
    }
    return height
  }
  
  var nameHeight: CGFloat {
    var height: CGFloat = 0
    for order in orders {
      height += order.nameHeight
    }
    return height
  }
}

struct Order: Decodable {
  let name: String
  let combo: [String]?
  let amount: Int
  let price: String
}

extension Order {
  var nameHeight: CGFloat {
    let att = NSAttributedString(string: name, attributes: [NSAttributedString.Key.font : UIFont.systemFont(ofSize: 26, weight: .regular)])
    let size = CGSize(width: ((420 * 0.6) - 10), height: 60)
    let rect = att.boundingRect(with: size, options: .usesLineFragmentOrigin, context: nil)
    return rect.height + 10
  }
  
  var comboHeight: CGFloat {
    if let combo = combo {
      return 27.5 * CGFloat(combo.count)
    }
    return 0
  }
}

struct Gift: Decodable {
  let name: String
  let amount: Int
  let price: String
}

struct Discount: Decodable {
  let name: String
  let amount: Int
  let price: String
}
